﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.OleDb;

namespace COntaBancaria_Access
{
    class Program
    {
        public static class BancodeDados
        {
            public static OleDbConnection AbreConexao()
            {
                return new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=D:\sergio\contabancaria.mdb");
            }
        }
        
        public class ContaBancaria
        {
            public double Saldo { get; set; }
            public int Nro_conta { get; set; }

            public void Depositar()
            {
                int qualconta;
                double valordep;

                Console.Write("Qual o nuúmero da conta para depósito? ");
                qualconta = Convert.ToInt32(Console.ReadLine());
                OleDbConnection cnn = BancodeDados.AbreConexao();
                OleDbCommand cmd = new OleDbCommand();
                cnn.Open();
                cmd.Connection = cnn;
                cmd.CommandText = "Select * from conta where nro_conta = " + qualconta;
                OleDbDataReader resp = cmd.ExecuteReader();
                if (resp.HasRows)
                {
                    resp.Read();
                    this.Saldo = Convert.ToDouble(resp["saldo"]);
                    resp.Close();
                    this.Nro_conta = qualconta;
                    Console.Write("Qual valor a ser depositado? ");
                    valordep = Convert.ToDouble(Console.ReadLine());
                    this.Saldo += valordep;
                    cmd.CommandText = "Insert into operacoes values (" + this.Nro_conta + ",\"D\",\"" + valordep + "\")";
                    cmd.ExecuteNonQuery();
                    cmd.CommandText = "Update conta set saldo = \"" + this.Saldo + "\" where nro_conta = " + this.Nro_conta;
                    cmd.ExecuteNonQuery();
             
                }
                else
                {
                    Console.WriteLine("Conta inexistente!");
                }
                cnn.Close();
            }

            public void Sacar()
            {
                int qualconta;
                double valorsaque;

                Console.Write("Qual o nuúmero da conta para sacar? ");
                qualconta = Convert.ToInt32(Console.ReadLine());
                OleDbConnection cnn = BancodeDados.AbreConexao();
                OleDbCommand cmd = new OleDbCommand();
                cnn.Open();
                cmd.Connection = cnn;
                cmd.CommandText = "Select * from conta where nro_conta = " + qualconta;
                OleDbDataReader resp = cmd.ExecuteReader();
                if (resp.HasRows)
                {
                    resp.Read();
                    this.Saldo = Convert.ToDouble(resp["saldo"]);
                    resp.Close();
                    this.Nro_conta = qualconta;
                    Console.Write("Qual valor a ser sacado? ");
                    valorsaque = Convert.ToDouble(Console.ReadLine());
                    if (this.Saldo >= valorsaque)
                    {
                        this.Saldo -= valorsaque;
                        cmd.CommandText = "Insert into operacoes values (" + this.Nro_conta + ",\"S\",\"" + valorsaque + "\")";
                        cmd.ExecuteNonQuery();
                        cmd.CommandText = "Update conta set saldo = \"" + this.Saldo + "\" where nro_conta = " + this.Nro_conta;
                        cmd.ExecuteNonQuery();
                    }
                    else
                    {
                        Console.WriteLine("Saldo Insuficiente!");
                    }
                }
                else
                {
                    Console.WriteLine("Conta inexistente!");
                }
                cnn.Close();
            }

            public void Extrato()
            {
                int qualconta;
                
                Console.Write("Qual o nuúmero da conta para extrato? ");
                qualconta = Convert.ToInt32(Console.ReadLine());
                OleDbConnection cnn = BancodeDados.AbreConexao();
                OleDbCommand cmd = new OleDbCommand();
                cnn.Open();
                cmd.Connection = cnn;
                cmd.CommandText = "Select * from conta where nro_conta = " + qualconta;
                OleDbDataReader resp = cmd.ExecuteReader();
                if (resp.HasRows)
                {
                    resp.Read();
                    this.Saldo = Convert.ToDouble(resp["saldo"]);
                    resp.Close();
                    this.Nro_conta = qualconta;
                    resp.Close();
                    cmd.CommandText = "Select * from operacoes where nro_conta = " + qualconta;
                    resp = cmd.ExecuteReader();
                    if (resp.HasRows)
                    {
                        Console.WriteLine("Conta\tOperacao\tValor (R$)");
                        while(resp.Read())
                        {
                            Console.WriteLine("{0}\t    {1}\t\t{2}", resp[0].ToString(), resp[1], resp[2].ToString());
                        }
                        Console.WriteLine("════════════════════════════════════\n\t\tSALDO:\tR$ {0}", this.Saldo.ToString());
                    }
                    else
                    {
                        Console.WriteLine("Nenhuma operação efetuada");
                    }
                }
                else
                {
                    Console.WriteLine("Conta inexistente!");
                }
                cnn.Close();
            }
            public void ExtratoDepositos()
            {
                int qualconta;
                double total=0;
                Console.Write("Qual o número da conta para extrato de depósitos? ");
                qualconta = Convert.ToInt32(Console.ReadLine());
                OleDbConnection cnn = BancodeDados.AbreConexao();
                OleDbCommand cmd = new OleDbCommand();
                cnn.Open();
                cmd.Connection = cnn;
                cmd.CommandText = "Select * from conta where nro_conta = " + qualconta;
                OleDbDataReader resp = cmd.ExecuteReader();
                if (resp.HasRows)
                {
                    resp.Read();
                    this.Saldo = Convert.ToDouble(resp["saldo"]);
                    resp.Close();
                    this.Nro_conta = qualconta;
                    resp.Close();
                    cmd.CommandText = "Select * from operacoes where operacao = \'D\' and nro_conta = " + qualconta;
                    resp = cmd.ExecuteReader();
                    if (resp.HasRows)
                    {
                        Console.WriteLine("Conta\tOperacao\tValor (R$)");
                        while (resp.Read())
                        {
                            Console.WriteLine("{0}\t    {1}\t\t{2}", resp[0].ToString(), resp[1], resp[2].ToString());
                            total += Convert.ToDouble(resp[2]);
                        }
                        Console.WriteLine("════════════════════════════════════\n\t\tSOMA:\tR$ {0}", total.ToString());
                    }
                    else
                    {
                        Console.WriteLine("Nenhuma operação efetuada");
                    }
                }
                else
                {
                    Console.WriteLine("Conta inexistente!");
                }
                cnn.Close();
            }

            public void ExtratoSaques()
            {
                int qualconta;
                double total = 0;
                Console.Write("Qual o número da conta para extrato de saques? ");
                qualconta = Convert.ToInt32(Console.ReadLine());
                OleDbConnection cnn = BancodeDados.AbreConexao();
                OleDbCommand cmd = new OleDbCommand();
                cnn.Open();
                cmd.Connection = cnn;
                cmd.CommandText = "Select * from conta where nro_conta = " + qualconta;
                OleDbDataReader resp = cmd.ExecuteReader();
                if (resp.HasRows)
                {
                    resp.Read();
                    this.Saldo = Convert.ToDouble(resp["saldo"]);
                    resp.Close();
                    this.Nro_conta = qualconta;
                    resp.Close();
                    cmd.CommandText = "Select * from operacoes where operacao = \'S\' and nro_conta = " + qualconta;
                    resp = cmd.ExecuteReader();
                    if (resp.HasRows)
                    {
                        Console.WriteLine("Conta\tOperacao\tValor (R$)");
                        while (resp.Read())
                        {
                            Console.WriteLine("{0}\t    {1}\t\t{2}", resp[0].ToString(), resp[1], resp[2].ToString());
                            total += Convert.ToDouble(resp[2]);
                        }
                        Console.WriteLine("════════════════════════════════════\n\t\tSOMA:\tR$ {0}", total.ToString());
                    }
                    else
                    {
                        Console.WriteLine("Nenhuma operação efetuada");
                    }
                }
                else
                {
                    Console.WriteLine("Conta inexistente!");
                }
                cnn.Close();
            }

        }
        static void Main(string[] args)
        {
            ContaBancaria conta = new ContaBancaria();
            string opc=" ";
            do
            {
                Console.WriteLine("Contole de contas");
                Console.WriteLine("1 - Depositar\n2 - Sacar\n3 - Extrato");
                Console.WriteLine("4 - Extrado de Depósitos\n5 - Extrato de Saques\n0 - Sair");
                Console.Write("\nQual opção desejada? ");
                opc = Console.ReadLine();
                switch (opc)
                { 
                    case "0":
                        Console.WriteLine("Até breve");
                        Console.WriteLine("Pressione qualquer tecla para continuar . . .");
                        Console.ReadKey();
                        break;
                    case "1":
                        conta.Depositar();
                        Console.WriteLine("Pressione qualquer tecla para continuar . . .");
                        Console.ReadKey();
                        break;
                    case "2":
                        conta.Sacar();
                        Console.WriteLine("Pressione qualquer tecla para continuar . . .");
                        Console.ReadKey();
                        break;
                    case "3":
                        conta.Extrato();
                        Console.WriteLine("Pressione qualquer tecla para continuar . . .");
                        Console.ReadKey();
                        break;
                    case "4":
                        conta.ExtratoDepositos();
                        Console.WriteLine("Pressione qualquer tecla para continuar . . .");
                        Console.ReadKey();
                        break;
                    case "5":
                        conta.ExtratoSaques();
                        Console.WriteLine("Pressione qualquer tecla para continuar . . .");
                        Console.ReadKey();
                        break;
                    default:
                        Console.WriteLine("Opção inválida");
                        Console.WriteLine("Pressione qualquer tecla para continuar . . .");
                        Console.ReadKey();
                        break;
                }
                Console.Clear();
            } while (opc != "0");
        }
    }
}
